Package com.sas.metadata.remote

# Interface Hierarchy

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Hierarchy extends PrimaryType
An arrangement of members of a dimension into levels that are based on parent-child relationships. Members of a hierarchy are arranged from more general to more specific. For example, in a Time dimension, a hierarchy might consist of the members Year, Quarter, Month, and Day. In a Geography dimension, a hierarchy might consist of the members Country, State or Province, and City. More than one hierarchy can be defined for a dimension. Each hierarchy provides a navigational path that enables users to drill down to increasing levels of detail. See also CalculatedMember, Level.

Attributes of Hierarchy are:

- `Cardinality`
- `UniqueName`
- `DefaultMember`
- `AllMember`

Associations of Hierarchy are:

- `NamedSets`
- `OwningDimension`
- `CalculatedMembers`
- `Cubes`
- `Levels`
- `OLAPProperties`
- `RootHierarchyLevel`

## Usage

To create an instance of this Hierarchy, use the `factory` create methods.
Example: create a Hierarchy with name "Hierarchy_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Hierarchy myObject = (Hierarchy) factory.createComplexMetadataObject(objectStore, "Hierarchy_Object", MetadataObjects.HIERARCHY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_CALCULATEDMEMBERS_NAME`
  Constant used for the name of the CalculatedMembers association.
  `static final String`
  `ASSOCIATION_CUBES_NAME`
  Constant used for the name of the Cubes association.
  `static final String`
  `ASSOCIATION_LEVELS_NAME`
  Constant used for the name of the Levels association.
  `static final String`
  `ASSOCIATION_NAMEDSETS_NAME`
  Constant used for the name of the NamedSets association.
  `static final String`
  `ASSOCIATION_OLAPPROPERTIES_NAME`
  Constant used for the name of the OLAPProperties association.
  `static final String`
  `ASSOCIATION_OWNINGDIMENSION_NAME`
  Constant used for the name of the OwningDimension association.
  `static final String`
  `ASSOCIATION_ROOTHIERARCHYLEVEL_NAME`
  Constant used for the name of the RootHierarchyLevel association.
  `static final String`
  `ATTRIBUTE_ALLMEMBER_NAME`
  Constant used for the name of the AllMember attribute.
  `static final String`
  `ATTRIBUTE_CARDINALITY_NAME`
  Constant used for the name of the Cardinality attribute.
  `static final String`
  `ATTRIBUTE_DEFAULTMEMBER_NAME`
  Constant used for the name of the DefaultMember attribute.
  `static final String`
  `ATTRIBUTE_UNIQUENAME_NAME`
  Constant used for the name of the UniqueName attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAllMember()`
  Gets the `String` value of `AllMember`
  `int`
  `getAllMemberMaxLength()`
  Gets the maximum length of `AllMember`
  `int`
  `getAllMemberState()`
  Gets the Metadata State of `AllMember`
  `AssociationList`
  `getCalculatedMembers()`
  Gets the Association list of `CalculatedMembers`
  `AssociationList`
  `getCalculatedMembers(boolean fGoToServer)`
  Gets the Associationlist of `CalculatedMembers`
  `double`
  `getCardinality()`
  Gets the `double` value of `Cardinality`
  `int`
  `getCardinalityState()`
  Gets the Metadata State of `Cardinality`
  `AssociationList`
  `getCubes()`
  Gets the Association list of `Cubes`
  `AssociationList`
  `getCubes(boolean fGoToServer)`
  Gets the Associationlist of `Cubes`
  `String`
  `getDefaultMember()`
  Gets the `String` value of `DefaultMember`
  `int`
  `getDefaultMemberMaxLength()`
  Gets the maximum length of `DefaultMember`
  `int`
  `getDefaultMemberState()`
  Gets the Metadata State of `DefaultMember`
  `AssociationList`
  `getLevels()`
  Gets the Association list of `Levels`
  `AssociationList`
  `getLevels(boolean fGoToServer)`
  Gets the Associationlist of `Levels`
  `AssociationList`
  `getNamedSets()`
  Gets the AssociationList of `NamedSets`
  `AssociationList`
  `getNamedSets(boolean fGoToServer)`
  Gets the Associationlist of `NamedSets`
  `AssociationList`
  `getOLAPProperties()`
  Gets the Association list of `OLAPProperties`
  `AssociationList`
  `getOLAPProperties(boolean fGoToServer)`
  Gets the Associationlist of `OLAPProperties`
  `Dimension`
  `getOwningDimension()`
  Gets the `Dimension` for `OwningDimension`
  `AssociationList`
  `getOwningDimensions()`
  Gets the AssociationList of `OwningDimensions`
  `AssociationList`
  `getOwningDimensions(boolean fGoToServer)`
  Gets the Associationlist of `OwningDimensions`
  `HierarchyLevel`
  `getRootHierarchyLevel()`
  Gets the `HierarchyLevel` for `RootHierarchyLevel`
  `AssociationList`
  `getRootHierarchyLevels()`
  Gets the Association list of `RootHierarchyLevels`
  `AssociationList`
  `getRootHierarchyLevels(boolean fGoToServer)`
  Gets the Associationlist of `RootHierarchyLevels`
  `String`
  `getUniqueName()`
  Gets the `String` value of `UniqueName`
  `int`
  `getUniqueNameMaxLength()`
  Gets the maximum length of `UniqueName`
  `int`
  `getUniqueNameState()`
  Gets the Metadata State of `UniqueName`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `NamedSets`
  `OwningDimension`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningDimension`
  `void`
  `setAllMember(String inAllMember)`
  Sets the `AllMember` value and sets the state to MetadataState.LOCAL.
  `void`
  `setAllMember(String inAllMember, int state)`
  Sets the `AllMember` Metadata State.
  `void`
  `setAllMemberState(int state)`
  Sets the Metadata State of `AllMember`.
  `void`
  `setCalculatedMembers(AssociationList list)`
  Sets the `CalculatedMembers` list to be `list`.
  `void`
  `setCalculatedMembers(AssociationList inObjects, int state)`
  Sets the entire CalculatedMembers list to match the passed in AssociationList, sets the state of the CalculatedMembers
  `void`
  `setCardinality(double inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCardinality(double inCardinality, int state)`
  Sets the `Cardinality` Metadata State.
  `void`
  `setCardinality(String inCardinality)`
  Sets the `Cardinality` value and sets the state to MetadataState.LOCAL
  `void`
  `setCardinality(String inCardinality, int state)`
  Sets the `Cardinality` value and Metadata State.
  `void`
  `setCardinalityState(int state)`
  Sets the Metadata State of `Cardinality`.
  `void`
  `setCubes(AssociationList list)`
  Sets the `Cubes` list to be `list`.
  `void`
  `setCubes(AssociationList inObjects, int state)`
  Sets the entire Cubes list to match the passed in AssociationList, sets the state of the Cubes
  `void`
  `setDefaultMember(String inDefaultMember)`
  Sets the `DefaultMember` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDefaultMember(String inDefaultMember, int state)`
  Sets the `DefaultMember` Metadata State.
  `void`
  `setDefaultMemberState(int state)`
  Sets the Metadata State of `DefaultMember`.
  `void`
  `setLevels(AssociationList list)`
  Sets the `Levels` list to be `list`.
  `void`
  `setLevels(AssociationList inObjects, int state)`
  Sets the entire Levels list to match the passed in AssociationList, sets the state of the Levels
  `void`
  `setNamedSets(AssociationList list)`
  Sets the `NamedSets` list to be `list`.
  `void`
  `setNamedSets(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setOLAPProperties(AssociationList list)`
  Sets the `OLAPProperties` list to be `list`.
  `void`
  `setOLAPProperties(AssociationList inObjects, int state)`
  Sets the entire OLAPProperties list to match the passed in AssociationList, sets the state of the OLAPProperties
  `void`
  `setOwningDimension(Dimension inObject)`
  Sets the `OwningDimensions` list 0th element to be `inObject`.
  `void`
  `setOwningDimensions(AssociationList list)`
  Sets the `OwningDimensions` list to be `list`.
  `void`
  `setOwningDimensions(AssociationList list, int state)`
  Sets the `OwningDimensions` list to be `list`.
  `void`
  `setRootHierarchyLevel(HierarchyLevel inObject)`
  Sets the `RootHierarchyLevels` list 0th element to be `inObject`.
  `void`
  `setRootHierarchyLevels(AssociationList list)`
  Sets the `RootHierarchyLevels` list to be `list`.
  `void`
  `setRootHierarchyLevels(AssociationList list, int state)`
  Sets the `RootHierarchyLevels` list to be `list`.
  `void`
  `setUniqueName(String inUniqueName)`
  Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setUniqueName(String inUniqueName, int state)`
  Sets the `UniqueName` Metadata State.
  `void`
  `setUniqueNameState(int state)`
  Sets the Metadata State of `UniqueName`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_CARDINALITY_NAME

    static final String ATTRIBUTE_CARDINALITY_NAME
    Constant used for the name of the Cardinality attribute.

    Cardinality: The number of levels in the hierarchy.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_UNIQUENAME_NAME

    static final String ATTRIBUTE_UNIQUENAME_NAME
    Constant used for the name of the UniqueName attribute.

    UniqueName: The unique name for this hierarchy.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_DEFAULTMEMBER_NAME

    static final String ATTRIBUTE_DEFAULTMEMBER_NAME
    Constant used for the name of the DefaultMember attribute.

    DefaultMember: The default member for the hierarchy.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_ALLMEMBER_NAME

    static final String ATTRIBUTE_ALLMEMBER_NAME
    Constant used for the name of the AllMember attribute.

    AllMember: This is the member at the highest level of a rollup in the hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_NAMEDSETS_NAME

    static final String ASSOCIATION_NAMEDSETS_NAME
    Constant used for the name of the NamedSets association.

    NamedSets: The named sets for this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGDIMENSION_NAME

    static final String ASSOCIATION_OWNINGDIMENSION_NAME
    Constant used for the name of the OwningDimension association.

    OwningDimension: The dimension that contains this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CALCULATEDMEMBERS_NAME

    static final String ASSOCIATION_CALCULATEDMEMBERS_NAME
    Constant used for the name of the CalculatedMembers association.

    CalculatedMembers: The calculated members for this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_CUBES_NAME

    static final String ASSOCIATION_CUBES_NAME
    Constant used for the name of the Cubes association.

    Cubes: The list of cubes that support this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LEVELS_NAME

    static final String ASSOCIATION_LEVELS_NAME
    Constant used for the name of the Levels association.

    Levels: The list of levels that comprise this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OLAPPROPERTIES_NAME

    static final String ASSOCIATION_OLAPPROPERTIES_NAME
    Constant used for the name of the OLAPProperties association.

    OLAPProperties: The list of OLAP properties for this hierarchy.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ROOTHIERARCHYLEVEL_NAME

    static final String ASSOCIATION_ROOTHIERARCHYLEVEL_NAME
    Constant used for the name of the RootHierarchyLevel association.

    RootHierarchyLevel: The root level for this hierarchy.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningDimension`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `NamedSets`
    `OwningDimension`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinality

    double getCardinality() throws RemoteException
    Gets the `double` value of `Cardinality`
    Returns:
      The `Cardinality`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCardinalityState

    int getCardinalityState() throws RemoteException
    Gets the Metadata State of `Cardinality`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueName

    String getUniqueName() throws RemoteException
    Gets the `String` value of `UniqueName`
    Returns:
      The `UniqueName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameState

    int getUniqueNameState() throws RemoteException
    Gets the Metadata State of `UniqueName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getUniqueNameMaxLength

    int getUniqueNameMaxLength() throws RemoteException
    Gets the maximum length of `UniqueName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultMember

    String getDefaultMember() throws RemoteException
    Gets the `String` value of `DefaultMember`
    Returns:
      The `DefaultMember`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultMemberState

    int getDefaultMemberState() throws RemoteException
    Gets the Metadata State of `DefaultMember`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDefaultMemberMaxLength

    int getDefaultMemberMaxLength() throws RemoteException
    Gets the maximum length of `DefaultMember`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAllMember

    String getAllMember() throws RemoteException
    Gets the `String` value of `AllMember`
    Returns:
      The `AllMember`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAllMemberState

    int getAllMemberState() throws RemoteException
    Gets the Metadata State of `AllMember`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAllMemberMaxLength

    int getAllMemberMaxLength() throws RemoteException
    Gets the maximum length of `AllMember`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getNamedSets

    AssociationList getNamedSets() throws RemoteException, MdException
    Gets the AssociationList of `NamedSets`
    Returns:
      Returns the AssociationList of `NamedSets` which can be of type:
      NamedSet
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningDimensions

    AssociationList getOwningDimensions() throws RemoteException, MdException
    Gets the AssociationList of `OwningDimensions`
    Returns:
      Returns the AssociationList of `OwningDimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningDimension

    Dimension getOwningDimension() throws RemoteException, MdException
    Gets the `Dimension` for `OwningDimension`
    Returns:
      The `Dimension` ( `null` if not set) of `OwningDimension`which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCalculatedMembers

    AssociationList getCalculatedMembers() throws RemoteException, MdException
    Gets the Association list of `CalculatedMembers`
    Returns:
      The AssociationList of `CalculatedMembers` which can be of type:
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCubes

    AssociationList getCubes() throws RemoteException, MdException
    Gets the Association list of `Cubes`
    Returns:
      The AssociationList of `Cubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLevels

    AssociationList getLevels() throws RemoteException, MdException
    Gets the Association list of `Levels`
    Returns:
      The AssociationList of `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOLAPProperties

    AssociationList getOLAPProperties() throws RemoteException, MdException
    Gets the Association list of `OLAPProperties`
    Returns:
      The AssociationList of `OLAPProperties` which can be of type:
      OLAPProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getRootHierarchyLevels

    AssociationList getRootHierarchyLevels() throws RemoteException, MdException
    Gets the Association list of `RootHierarchyLevels`
    Returns:
      The AssociationList of `RootHierarchyLevels` which can be of type:
      HierarchyLevel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getRootHierarchyLevel

    HierarchyLevel getRootHierarchyLevel() throws RemoteException, MdException
    Gets the `HierarchyLevel` for `RootHierarchyLevel`
    Returns:
      The `HierarchyLevel` ( `null` if not set ) of `RootHierarchyLevel` which can be of type:
      HierarchyLevel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNamedSets

    AssociationList getNamedSets(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `NamedSets`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `NamedSets` which can be of type:
      NamedSet
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningDimensions

    AssociationList getOwningDimensions(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningDimensions`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningDimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCalculatedMembers

    AssociationList getCalculatedMembers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `CalculatedMembers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `CalculatedMembers` which can be of type:
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getCubes

    AssociationList getCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Cubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Cubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLevels

    AssociationList getLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Levels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Levels` which can be of type:
      Level
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOLAPProperties

    AssociationList getOLAPProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OLAPProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `OLAPProperties` which can be of type:
      OLAPProperty
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getRootHierarchyLevels

    AssociationList getRootHierarchyLevels(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `RootHierarchyLevels`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `RootHierarchyLevels` which can be of type:
      HierarchyLevel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setCardinality

    void setCardinality(double inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCardinality` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(double inCardinality, int state) throws RemoteException
    Sets the `Cardinality` Metadata State.
    Parameters:
      `inCardinality` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality) throws RemoteException
    Sets the `Cardinality` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inCardinality` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinality

    void setCardinality(String inCardinality, int state) throws RemoteException
    Sets the `Cardinality` value and Metadata State.
    Parameters:
      `inCardinality` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCardinalityState

    void setCardinalityState(int state) throws RemoteException
    Sets the Metadata State of `Cardinality`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName) throws RemoteException
    Sets the `UniqueName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inUniqueName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueName

    void setUniqueName(String inUniqueName, int state) throws RemoteException
    Sets the `UniqueName` Metadata State.
    Parameters:
      `inUniqueName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setUniqueNameState

    void setUniqueNameState(int state) throws RemoteException
    Sets the Metadata State of `UniqueName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultMember

    void setDefaultMember(String inDefaultMember) throws RemoteException
    Sets the `DefaultMember` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDefaultMember` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultMember

    void setDefaultMember(String inDefaultMember, int state) throws RemoteException
    Sets the `DefaultMember` Metadata State.
    Parameters:
      `inDefaultMember` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDefaultMemberState

    void setDefaultMemberState(int state) throws RemoteException
    Sets the Metadata State of `DefaultMember`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllMember

    void setAllMember(String inAllMember) throws RemoteException
    Sets the `AllMember` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inAllMember` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllMember

    void setAllMember(String inAllMember, int state) throws RemoteException
    Sets the `AllMember` Metadata State.
    Parameters:
      `inAllMember` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAllMemberState

    void setAllMemberState(int state) throws RemoteException
    Sets the Metadata State of `AllMember`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamedSets

    void setNamedSets(AssociationList list) throws RemoteException
    Sets the `NamedSets` list to be `list`. Objects of which can be of type:
    NamedSet
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNamedSets

    void setNamedSets(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimensions

    void setOwningDimensions(AssociationList list) throws RemoteException
    Sets the `OwningDimensions` list to be `list`. Object of which can be of type:
    Dimension
    SharedDimension
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimensions

    void setOwningDimensions(AssociationList list, int state) throws RemoteException
    Sets the `OwningDimensions` list to be `list`. Object of which can be of type:
    Dimension
    SharedDimension
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningDimension

    void setOwningDimension(Dimension inObject) throws RemoteException
    Sets the `OwningDimensions` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Dimension
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCalculatedMembers

    void setCalculatedMembers(AssociationList list) throws RemoteException
    Sets the `CalculatedMembers` list to be `list`. Objects of which can be of type:
    CalculatedMember
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCalculatedMembers

    void setCalculatedMembers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire CalculatedMembers list to match the passed in AssociationList, sets the state of the CalculatedMembers
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubes

    void setCubes(AssociationList list) throws RemoteException
    Sets the `Cubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubes

    void setCubes(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Cubes list to match the passed in AssociationList, sets the state of the Cubes
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList list) throws RemoteException
    Sets the `Levels` list to be `list`. Objects of which can be of type:
    Level
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLevels

    void setLevels(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Levels list to match the passed in AssociationList, sets the state of the Levels
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOLAPProperties

    void setOLAPProperties(AssociationList list) throws RemoteException
    Sets the `OLAPProperties` list to be `list`. Objects of which can be of type:
    OLAPProperty
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOLAPProperties

    void setOLAPProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire OLAPProperties list to match the passed in AssociationList, sets the state of the OLAPProperties
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setRootHierarchyLevels

    void setRootHierarchyLevels(AssociationList list) throws RemoteException
    Sets the `RootHierarchyLevels` list to be `list`. Objects of which can be of type:
    HierarchyLevel
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setRootHierarchyLevels

    void setRootHierarchyLevels(AssociationList list, int state) throws RemoteException
    Sets the `RootHierarchyLevels` list to be `list`. Objects of which can be of type:
    HierarchyLevel
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setRootHierarchyLevel

    void setRootHierarchyLevel(HierarchyLevel inObject) throws RemoteException
    Sets the `RootHierarchyLevels` list 0th element to be `inObject`.
    Parameters:
      `inObject` - HierarchyLevel
    Throws:
      `RemoteException` - If error communicating with remote object.